#include "TeensyStep.h"
#include "Arduino.h"

int currentPos;

float period = 100; //interval between counts in milliseconds
long counter = 0; //increment counter
unsigned long startMillis;
unsigned long currentMillis;
boolean counting = true;

float  speedFactor;
float  accelFactor;
float  moveto;

// stuff needed for SERIAL to work
String sendstr, pref;

String inData; //everything from Serial comes to this variable to then be processed.
String receptacle0, receptacle1;// this variable is used to store data that has been stripped from any letters, keeping numbers (in String form).
String letter0, letter1;//this variable holds the first letter of the incoming data.This first letter determines where to send the data.
float receivedint0, receivedint1; // Set value
//-------------------------------

RotateControl Rctl_0; 
RotateControl Rctl_1; 


Stepper Mtr_0(0, 1);  // STEP pin: 0, DIR pin: 1
Stepper Mtr_1(2, 3);
Stepper Mtr_2(4, 5);
Stepper Mtr_3(6, 7);

StepControl Sctl_0;
StepControl Sctl_1;


void setup() {


  Serial.begin(57600);
  Serial.println("");

  Mtr_0.setMaxSpeed(20000);
  Mtr_0.setAcceleration(20000);
  Mtr_1.setMaxSpeed(20000);
  Mtr_1.setAcceleration(20000);
  Mtr_2.setMaxSpeed(20000);
  Mtr_2.setAcceleration(20000);
  Mtr_3.setMaxSpeed(20000);
  Mtr_3.setAcceleration(20000);

  Rctl_0.rotateAsync(Mtr_0);
  Rctl_0.overrideSpeed(0); // start with stopped axis
  Rctl_1.rotateAsync(Mtr_1);
  Rctl_1.overrideSpeed(0); // start with stopped axis

}

 //---------------------------------function to split incoming data
 
String getValue(String data, char separator, int index)
{
    int found = 0;
    int strIndex[] = { 0, -1 };
    int maxIndex = data.length() - 1;

    for (int i = 0; i <= maxIndex && found <= index; i++) {
        if (data.charAt(i) == separator || i == maxIndex) {
            found++;
            strIndex[0] = strIndex[1] + 1;
            strIndex[1] = (i == maxIndex) ? i+1 : i;
        }
    }
    return found > index ? data.substring(strIndex[0], strIndex[1]) : "";
}

void loop() {

  while (Serial.available() > 0) {

    char received = Serial.read();
    inData += received;//the variable that holds the "raw" incoming string
    if (received == '\n')
    {

      receptacle0 = getValue(inData, ' ', 0);// hold the first axis data so that it can be stripped and used accordingly
      receptacle1 = getValue(inData, ' ', 1);//hold the second axis data so that it can be stripped and used accordingly
      String copyrcp0 = receptacle0;
      String copyrcp1 = receptacle1;
      letter0 = copyrcp0.remove(2, 16);//removes the numbers and keeps the first two letters
      letter1 = copyrcp1.remove(2, 16);//removes the numbers and keeps the first two letters
      receptacle0.remove(0, 2);//removes the first digit (a letter) and keeps the numbers which are still in tring form
      receptacle1.remove(0, 2);//removes the first digit (a letter) and keeps the numbers which are still in tring form
      receivedint0 = receptacle0.toInt();//this converts string of "numbers" to integers, needed to set steps, speed, etc.
      receivedint1 = receptacle1.toInt();//this converts string of "numbers" to integers, needed to set steps, speed, etc.
      inData = ""; // Clear received buffer
    }

  }//end while


  currentMillis = millis();

  //---------------------------------command to go to position

  if (letter0 == "G0")   {
    //Rctl_0.stop();
    moveto = receivedint0;
    Mtr_0.setTargetAbs(moveto);
    Sctl_0.moveAsync(Mtr_0);
    counting = true;
    letter0 = "qq";
  }
    if (letter1 == "G1")   {
    //Rctl_1.stop();
    moveto = receivedint1;
    Mtr_1.setTargetAbs(moveto);
    Sctl_1.moveAsync(Mtr_1);
    letter1 = "qq";
  }

 //---------------------------------command to reset currentPos to zero
if (letter0 == "Z0")  {
    Mtr_0.setPosition(0);
    letter0 = "qq";
}
if (letter1 == "Z1")  {
    Mtr_1.setPosition(0);
    letter1 = "qq";
}


   //---------------------------------command to set acceleration
  if (letter0 == "A0") {
    accelFactor = receivedint0 / 20000.0;
    Rctl_0.overrideAcceleration(accelFactor);
    letter0 = "qq";
  }
  
    if  (letter1 == "A1")  {
    accelFactor = receivedint1 / 20000.0;
    Rctl_1.overrideAcceleration(accelFactor);
    letter1 = "qq";
    }



  //---------------------------------command to STOP running move or jogging

  if (letter0  == "S0") { //STOP ALL
    Rctl_0.overrideSpeed(0);  
    letter0 = "qq";}
    
    if (letter1 =="S1")  {
    Rctl_1.overrideSpeed(0);  
    letter1 = "qq";}
    
  //---------------------------------command to run at specified speed
  
 if (letter0 == "J0")   { // move/jog 

  speedFactor = receivedint0 / 20000.0;
    Rctl_0.overrideSpeed(speedFactor);
    counting = true;
    letter0 = "qq";
  }

 if (letter1 == "J1")   { // move/jog 

  speedFactor = receivedint1 / 20000.0;
    Rctl_1.overrideSpeed(speedFactor);
    counting = true;
    letter1 = "qq";
  }

  //-------------------------------------------------------------

  if (counting) {

    if (currentMillis - startMillis >= period) {
      counter++;
      
            int p0 = Mtr_0.getPosition();
            int p1 = Mtr_1.getPosition();
            int p2 = Mtr_2.getPosition();
            int p3 = Mtr_3.getPosition();

      Serial.printf("P0%i,\P1%i,\P2%i,\P3%i\n", p0, p1, p2, p3);

      startMillis = currentMillis;
    }//end current millis
  }//end counting

}//end loop